<template>
  <ul class="category-list">
    <li
      v-for="category in categories"
      :key="category.id"
      :class="{ 'has-subcategory': category.children.length }"
    >
      <component
        :is="!category.children.length ? 'nuxt-link' : 'span'"
        :to="`/category${category.path}`"
        @click="visible[category.id] = !visible[category.id]"
      >
        {{ category.name }}
      </component>
      <transition-collapse v-if="category.children.length" :easing="'ease'">
        <category-list
          v-show="visible[category.id]"
          :categories="category.children"
          @click="$emit('click', $event)"
        />
      </transition-collapse>
    </li>
  </ul>
</template>

<script>
const TransitionCollapse = () =>
  import('@/components/transitions/TransitionCollapse.vue')

export default {
  name: 'CategoryList',
  components: { TransitionCollapse },
  /**
   * @typedef Props
   * @property {Category[]} categories
   */
  /** @type {Props} */
  props: {
    categories: {
      type: Array,
      required: true,
    },
  },
  data() {
    return {
      visible: Object.fromEntries(
        this.categories.map((category) => [category.id, false])
      ),
    }
  },
}
</script>
